#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <ctype.h>
// Screen control:
#include <curses.h>
// Sockets:
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

WINDOW *w;   
   
void initialize() {
    w = initscr(); 
    //cbreak(); 
    noecho();
    nonl();
    //intrflush(stdscr, FALSE);
    keypad(stdscr, TRUE);
}

/**
 * Unbuffered getchar
 */
char myGetChar() {
    int ch = getch();
    switch(ch) {
        case KEY_UP:    ch = 'A'; break;
        case KEY_DOWN:  ch = 'Z'; break;
        case KEY_RIGHT: ch = '.'; break;
        case KEY_LEFT:  ch = ','; break;
        default: 
            // do nothing
            break;
    }
    return ch;
}


void pressAnyKey() {
    printf("Press any key...");
    myGetChar();
    printf("\n");
}

int connectClient(const char *address, int port) {
    struct sockaddr_in addr;
    int sd;
    memset(&addr, 0, sizeof(addr));
    sd = socket(PF_INET, SOCK_STREAM, 0);
    if (sd == -1) {
        fprintf(stderr, "Error creating socket\n");
        return -1;
    }
    addr.sin_family = AF_INET;
    addr.sin_port = htons(port);
    addr.sin_addr.s_addr = inet_addr("127.0.0.1");
    //inet_aton(address, &addr.sin_addr);
    if (connect(sd, (struct sockaddr *)&addr, sizeof(addr)) != 0) {
        fprintf(stderr, "Could not connect\n");
        return -1;
    }
    return sd;
}

void sendMovement(int socket, int x, int y) {
    int rc;
    char buffer[64];
    snprintf(buffer, sizeof(buffer), "[%d,%d]\r\n", x, y);
    buffer[63] = 0;
    rc = send(socket, buffer, strlen(buffer), 0);
    //printf("%d\n", rc);
}

int main(int argc, char **argv) {
    int socket = connectClient("127.0.0.1", 5399);
    char c;
    int speed = 15;
    setvbuf(stdin, (char *) 0, _IONBF, 0);
    if (socket == -1) {
        fprintf(stderr, "Cannot continue\n");
        return 1;
    }
    initialize();
    printw("MOVEMENT:\n");
    printw( 
           "      A\n"
           " , [space] .\n"
           "      Z\n"
           "That is, left hand is up/down, right hand is left/right, space stops\n"
           "You can also use the arrow keys.\n"
           "Use 1 through 5 to select speed multiplier.\n"
           "Press 'Q' to quit\n");
    do {
        wprintf("ninja\n");
        c = toupper(myGetChar());
        switch(c) {
            case 'A':
                sendMovement(socket, 0, speed * -1);
                break;
            case 'Z':
                sendMovement(socket, 0, speed);
                break;
            case ',':
                sendMovement(socket, speed * -1, 0);
                break;
            case '.':
                sendMovement(socket, speed, 0);
                break;
            case '1':
            case '2':
            case '3':
            case '4':
            case '5':
                speed = (c - '0' + 2) * 5;
                printw("New speed multiplier is %d\n", speed);
                break;
            case ' ':
                sendMovement(socket, 0, 0);
                break;
        }
    } while (c != 'Q');
    return 0;
}
